
//: C11:TemporaryUnlocking.cpp
// Czasowe odblokowywanie innej bariery
//{L} ZThread
#include "zthread/Thread.h"
#include "zthread/Mutex.h"
#include "zthread/Guard.h"
using namespace ZThread;

class TemporaryUnlocking {
  Mutex lock;
public:
  void f() {
    Guard<Mutex> g(lock);
    // pozyskanie blokady
    // ...
    {
      Guard<Mutex, UnlockedScope> h(g);
      // zwolnienie blokady
      // ...
      // pozyskanie blokady
    }
    // ...
    // zwolnienie blokady
  }
};

int main() {
  TemporaryUnlocking t;
  t.f();
} ///:~
